def zbx_env_search_string(svc)
  search_string = "zabbix_is_#{svc}:true"
  if node['zabbix'] && node['zabbix']['search_environment']
    search_string += " AND chef_environment:#{node['zabbix']['search_environment']}"
  else
    search_string += " AND chef_environment:#{node.chef_environment}"
  end
  search_string
end

def proxies
  search_string = zbx_env_search_string('proxy')

  search(:node, search_string)
end

# Returns an integer between 0 and 255 based on the
# Node's FQDN (should be randomly distributed but repeatable)
def node_proxy_index
  Digest::MD5.hexdigest(node['fqdn'])[0..1].to_i(16)
end

# Returns the proxy id
# based on the FQDN of this node and the
# number of proxies in this search environment
def proxy_id(number_of_proxies)
  node_proxy_index % number_of_proxies
end

# Retrieves the node object for my specific
# proxy.
def my_proxy
  ps = proxies
  raise 'No Proxies in this Environment' unless ps.length > 0 
  ps[proxy_id(ps.length)]
end

def update_for_proxy(nr)
  proxy_node = my_proxy
  nr.server = proxy_node['ipaddress'] if nr.server == 'DYNAMIC'
  nr.server_active = proxy_node['ipaddress'] if nr.server_active == 'DYNAMIC'
end
