provides :livelink_zabbix_proxy

property :name, String, name_property: true
property :version, String, default: node['zabbix']['repo_version']
property :proxy_mode, Integer, default: 0
property :server_addr, String, default: 'zbx.livelink.io'
property :server_port, Integer, default: 10_051
property :hostname_item, String, default: node['fqdn']
property :listen_port, Integer, default: 10_051
property :log_file, String, default: '/var/log/zabbix/zabbix_proxy.log'
property :log_file_size, Integer, default: 1024
property :debug_level, [0, 1, 2, 3, 4, 5], default: 3
property :pid_file, String, default: '/var/run/zabbix/zabbix_proxy.pid'
property :db_host, String, default: 'localhost'
property :db_name, String, default: 'zabbix_proxy'
property :db_user, String, default: 'zabbix'
property :db_password, String, default: 'GLqlqjIbcJpM'
property :db_socket, String, default: '/var/run/mysqld/mysqld.sock'
property :db_port, Integer, default: 3306
property :proxy_local_buffer, Integer, default: 0
property :proxy_offline_buffer, Integer, default: 12
property :heartbeat_frequency, Integer, default: 60
property :config_frequency, Integer, default: 3600
property :data_sender_frequency, Integer, default: 15
property :start_pollers, Integer, default: 5
property :start_pollers_unreachable, Integer, default: 1
property :start_trappers, Integer, default: 5
property :start_pingers, Integer, default: 2
property :start_discoverers, Integer, default: 0
property :start_http_pollers, Integer, default: 1
property :snmp_trapper_file, String, default: '/tmp/zabbix_traps.tmp'
property :start_snmp_trapper, Integer, default: 1
property :listen_ip, String, default: '0.0.0.0'
property :housekeeping_frequency, Integer, default: 1
property :cache_size, String, default: '8M'
property :start_db_syncers, Integer, default: 4
property :history_cache_size, String, default: '8M'
property :history_text_cache_size, String, default: '16M'
property :timeout, Integer, default: 15
property :trapper_timeout, Integer, default: 300
property :unreachable_period, Integer, default: 45
property :unavailable_delay, Integer, default: 60
property :unreachable_delay, Integer, default: 30
property :external_scripts, String, default: '/usr/lib/zabbix/externalscripts'
property :fping_location, String, default: '/usr/bin/fping'
property :fping6_location, String, default: '/usr/bin/fping6'
property :log_slow_queries, Integer, default: 60
property :tmp_dir, String, default: '/tmp'
property :allow_root, Integer, default: 0
property :user, String, default: 'zabbix'
property :include, [Array, String],
         default: '/etc/zabbix/zabbix_proxy.conf.d/*.conf'

action :create do
  node.default['zabbix']['is_proxy'] = true
  node.save
  livelink_zabbix_repo new_resource.version

  package 'zabbix-proxy-mysql' do
    notifies :restart, 'service[zabbix-proxy]', :delayed
  end

  directory '/etc/zabbix/zabbix_proxy.conf.d' do
    owner 'zabbix'
    group 'zabbix'
  end

  template '/etc/zabbix/zabbix_proxy.conf' do
    source 'proxy/zabbix_proxy.conf.erb'
    cookbook 'livelink-zabbix'
    owner 'zabbix'
    group 'zabbix'
    mode '0600'
    variables resource: new_resource
    notifies :restart, 'service[zabbix-proxy]', :delayed
  end

  file new_resource.snmp_trapper_file do
    action :create_if_missing
    owner 'zabbix'
    group 'zabbix'
  end

  service 'zabbix-proxy' do
    action [:start, :enable]
  end
end
