provides :zabbix_user_parameters, platform_family: 'debian'
property :name, String, name_property: true
property :parameters, [String, Array, Hash], required: true

default_action :create

action :create do
  case new_resource.parameters.class
  when String
    template "/etc/zabbix/zabbix_agent.d/50-up-#{new_resource.name}.conf" do
      source 'agent/_agent_user_parameter.erb'
      variables name: new_resource.name, command: new_resource.parameters
      notifies :restart, 'service[zabbix-agent]', :delayed
      cookbook 'livelink-zabbix'
    end
  when Hash
    template "/etc/zabbix/zabbix_agent.d/50-up-#{new_resource.name}.conf" do
      source 'agent/_agent_user_parameter.erb'
      variables name: new_resource.parameters[:name],
                command: new_resource.parameters[:command]
      notifies :restart, 'service[zabbix-agent]', :delayed
      cookbook 'livelink-zabbix'
    end
  when Array
    template "/etc/zabbix/zabbix_agent.d/51-up-#{new_resource.name}.conf" do
      source 'agent/agent_user_parameters.erb'
      variables parameters: new_resource.parameters
      notifies :restart, 'service[zabbix-agent]', :delayed
      cookbook 'livelink-zabbix'
    end
  else
    return 'Unsupported Parameter type'
  end
end
